#include<bits/stdc++.h>
using namespace std;
int a[1000][1000];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m,p,k=0,sb=0;
    cin>>m>>n>>p;
    p--;
    pair<int,int>b[4]={{0,1},{1,0},{0,-1},{-1,0}};
    
    for (int i=0;i<n;i++){
        for (int j=0;j<n;j++){
            a[i][j]=-1;
        }
    }
    int x=0,y=0;
    for (int i=0;i<n*n;i++){
        a[x][y]=m;
        m++;
        if (b[k].first+x>=n||b[k].first+x<0||b[k].second+y>=n||b[k].second+y<0||a[b[k].first+x][b[k].second+y]!=-1){
            k=(k+1)%4;
        }
        x+=b[k].first;
        y+=b[k].second;
    }
    for (int j=0;j<n;j++){
        sb+=a[p][j];
    }
    cout<<sb;
    return 0;
}

